-- Module:	tax
-- Author:	Team LTW
-- Start project: 21.11.2017 
------------------------------------------------------------------------------------------------------
-- Version: 1.0.0.0
------------------------------------------------------------------------------------------------------
-- Copyright (c) Team LTW, november 2017
------------------------------------------------------------------------------------------------------

tax = {};
addModEventListener(tax);

print("-- loaded taxModule V1.0.0.0 -- (by Team LTW)");

function tax:loadMap(name)
	self.difficulty = g_currentMission.loadingScreen.missionInfo.difficulty;
	self.payTax = true;
	self.profitTax = 0;
	self.exisits = false;
	
	tax.saveFile = g_currentMission.missionInfo:getSavegameDirectory(g_currentMission.missionInfo.savegameIndex).."/financeExtension.xml";
	if fileExists(tax.saveFile) then
		xml = loadXMLFile("financeExtensionFile", tax.saveFile)
		self.profitTax = getXMLFloat(xml, "financeExtension.taxModul.profitTax");
		self.exisits = true;
	end;
g_careerScreen.saveSavegame = Utils.appendedFunction(g_careerScreen.saveSavegame, tax.saveTaxToXML);			
end;

function tax:deleteMap()
end;

function tax:mouseEvent(posX, posY, isDown, isUp, button)
end;

function tax:keyEvent(unicode, sym, modifier, isDown)
end;

function tax:update(dt)
	if g_currentMission.environment.currentDay > 1 then	
		if g_currentMission.environment.currentHour == 9 and self.payTax ~= false then
			self.payTax = false;
		end;

		if g_currentMission.environment.currentHour == 10 and self.payTax == false then	
			if g_server ~= nil then
				local yesterday = g_currentMission.environment.currentDay - 1;
	------------------------------------------------------------------------------------------------------
	-- income / day
	------------------------------------------------------------------------------------------------------				
				self.propertyIncome = 0;
				self.soldWood = 0;
				self.soldBales = 0;
				self.soldWool = 0;
				self.soldMilk = 0;
				self.harvestIncome = 0;
				self.incomeBga = 0;
				self.missionIncome = 0;
				self.other = 0;
				
				self.lastPropertyIncome = g_currentMission.missionStats.financeStatsHistory[yesterday].propertyIncome;
				self.lastSoldWood = g_currentMission.missionStats.financeStatsHistory[yesterday].soldWood;	
				self.lastSoldBales = g_currentMission.missionStats.financeStatsHistory[yesterday].soldBales;	
				self.lastSoldWool = g_currentMission.missionStats.financeStatsHistory[yesterday].soldWool;	
				self.lastSoldMilk = g_currentMission.missionStats.financeStatsHistory[yesterday].soldMilk;	
				self.lastHarvestIncome = g_currentMission.missionStats.financeStatsHistory[yesterday].harvestIncome;
				self.lastIncomeBga = g_currentMission.missionStats.financeStatsHistory[yesterday].incomeBga;
				self.lastMissionIncome = g_currentMission.missionStats.financeStatsHistory[yesterday].missionIncome;
				self.lastOther = g_currentMission.missionStats.financeStatsHistory[yesterday].other;					
			
				if self.lastPropertyIncome > 0 then
					self.propertyIncome = self.lastPropertyIncome;
				end;
				if self.lastSoldWood > 0 then
					self.soldWood = self.lastSoldWood;
				end;
				if self.lastSoldBales > 0 then
					self.soldBales = self.lastSoldBales;
				end;
				if self.lastSoldWool > 0 then
					self.soldWool = self.lastSoldWool;
				end;
				if self.lastSoldMilk > 0 then
					self.soldMilk = self.lastSoldMilk;
				end;
				if self.lastHarvestIncome > 0 then
					self.harvestIncome = self.lastHarvestIncome;
				end;
				if self.lastIncomeBga > 0 then
					self.incomeBga = self.lastIncomeBga;
				end;
				if self.lastMissionIncome > 0 then
					self.missionIncome = self.lastMissionIncome;
				end;
				
				if self.lastOther > 0 and self.exisits == false then
					self.other = self.lastOther;
					self.exisits = true;
				end;
				
				--fixed "other"
				if self.profitTax > 0 then
					self.realLastOther = self.lastOther + self.profitTax;		
					if self.realLastOther > 0 then
						self.other = self.realLastOther;
					end;
				end;
					
				self.totalIncome = self.propertyIncome + self.soldWood + self.soldBales + self.soldWool + self.soldMilk + self.harvestIncome + self.incomeBga + self.missionIncome + self.other;

				print("Income of day "..tostring(yesterday)..": "..tostring(self.totalIncome));			
	------------------------------------------------------------------------------------------------------	
	-- cost / day
	------------------------------------------------------------------------------------------------------				
				self.newVehiclesCost = 0;
				self.newAnimalsCost = 0;
				self.constructionCost = 0;
				self.fieldPurchase = 0;
				self.vehicleRunningCost = 0;
				self.vehicleLeasingCost = 0;
				self.animalUpkeep = 0;
				self.propertyMaintenance = 0;
				self.purchaseFuel = 0;
				self.purchaseSeeds = 0;
				self.purchaseFertilizer = 0;
				self.purchaseSaplings = 0;
				self.purchaseWater = 0;
				self.wagePayment = 0;
				self.loanInterest = 0;
				
				self.lastNewVehiclesCost = g_currentMission.missionStats.financeStatsHistory[yesterday].newVehiclesCost
				self.lastNewAnimalsCost = g_currentMission.missionStats.financeStatsHistory[yesterday].newAnimalsCost	
				self.lastConstructionCost = g_currentMission.missionStats.financeStatsHistory[yesterday].constructionCost	
				self.lastFieldPurchase = g_currentMission.missionStats.financeStatsHistory[yesterday].fieldPurchase	
				self.lastVehicleRunningCost = g_currentMission.missionStats.financeStatsHistory[yesterday].vehicleRunningCost	
				self.lastVehicleLeasingCost = g_currentMission.missionStats.financeStatsHistory[yesterday].vehicleLeasingCost
				self.lastAnimalUpkeep = g_currentMission.missionStats.financeStatsHistory[yesterday].animalUpkeep
				self.lastPropertyMaintenance = g_currentMission.missionStats.financeStatsHistory[yesterday].propertyMaintenance
				self.lastPurchaseFuel = g_currentMission.missionStats.financeStatsHistory[yesterday].purchaseFuel
				self.lastPurchaseSeeds = g_currentMission.missionStats.financeStatsHistory[yesterday].purchaseSeeds
				self.lastPurchaseFertilizer = g_currentMission.missionStats.financeStatsHistory[yesterday].purchaseFertilizer
				self.lastPurchaseSaplings = g_currentMission.missionStats.financeStatsHistory[yesterday].purchaseSaplings
				self.lastPurchaseWater = g_currentMission.missionStats.financeStatsHistory[yesterday].purchaseWater
				self.lastWagePayment = g_currentMission.missionStats.financeStatsHistory[yesterday].wagePayment
				self.lastLoanInterest = g_currentMission.missionStats.financeStatsHistory[yesterday].loanInterest
				
				if self.lastNewVehiclesCost < 0 then
					self.newVehiclesCost = self.lastNewVehiclesCost;
				end;
				if self.lastNewAnimalsCost < 0 then
					self.newAnimalsCost = self.lastNewAnimalsCost;
				end;
				if self.lastConstructionCost < 0 then
					self.constructionCost = self.lastConstructionCost;
				end;
				if self.lastFieldPurchase < 0 then
					self.fieldPurchase = self.lastFieldPurchase;
				end;
				if self.lastVehicleRunningCost < 0 then
					self.vehicleRunningCost = self.lastVehicleRunningCost;
				end;
				if self.lastVehicleLeasingCost < 0 then
					self.vehicleLeasingCost = self.lastVehicleLeasingCost;
				end;
				if self.lastAnimalUpkeep < 0 then
					self.animalUpkeep = self.lastAnimalUpkeep;
				end;
				if self.lastPropertyMaintenance < 0 then
					self.propertyMaintenance = self.lastPropertyMaintenance;
				end;
				if self.lastPurchaseFuel < 0 then
					self.purchaseFuel = self.lastPurchaseFuel;
				end;
				if self.lastPurchaseSeeds < 0 then
					self.purchaseSeeds = self.lastPurchaseSeeds;
				end;
				if self.lastPurchaseFertilizer < 0 then
					self.purchaseFertilizer = self.lastPurchaseFertilizer;
				end;
				if self.lastPurchaseSaplings < 0 then
					self.purchaseSaplings = self.lastPurchaseSaplings;
				end;
				if self.lastPurchaseWater < 0 then
					self.purchaseWater = self.lastPurchaseWater;
				end;
				if self.lastWagePayment < 0 then
					self.wagePayment = self.lastWagePayment;
				end;
				if self.lastLoanInterest < 0 then
					self.loanInterest = self.lastLoanInterest;
				end;
					
				self.totalCost = self.newVehiclesCost + self.newAnimalsCost + self.constructionCost + self.fieldPurchase + self.vehicleRunningCost + self.vehicleLeasingCost + self.animalUpkeep + self.propertyMaintenance + self.purchaseFuel + self.purchaseSeeds + self.purchaseFertilizer + self.purchaseSaplings + self.purchaseWater + self.wagePayment + self.loanInterest;
					
				print("Cost of day "..tostring(yesterday)..": "..tostring(self.totalCost));
			
	------------------------------------------------------------------------------------------------------
	-- profit / day
	------------------------------------------------------------------------------------------------------
					self.profit = self.totalIncome + self.totalCost;
					
						if self.profit <= 0 then
							self.profit = 0;
						end;				
	------------------------------------------------------------------------------------------------------
	-- tax / day
	------------------------------------------------------------------------------------------------------			
				if self.difficulty == 1 then
					self.profitTax = self.profit * 0.1;
				elseif self.difficulty == 2 then
					self.profitTax = self.profit * 0.15;
				elseif self.difficulty == 3 then
					self.profitTax = self.profit * 0.19;
				end;
				
				self.taxes = self.profitTax * (-1);
					
				print("tax amount of day "..tostring(yesterday)..": "..tostring(self.profitTax));

				g_currentMission:addSharedMoney(self.taxes, "other")
				
				self.taxPrintSum = self.taxes;
				g_currentMission:addHelpButtonText(g_i18n:getText("tax"))
				g_currentMission:addMoneyChange(self.taxPrintSum, FSBaseMission.MONEY_TYPE_SINGLE, true, g_i18n:getText("tax"));
			end;
			self.payTax = true;
		end;
	end;		
end;

function tax:saveTaxToXML()
	if not fileExists(tax.saveFile) then
		xml = createXMLFile("financeExtensionFile", tax.saveFile, "financeExtension")
	end;	
	setXMLFloat(xml, "financeExtension.taxModul.profitTax", tax.profitTax);
	saveXMLFile(xml);
	delete(xml);
end;

function tax:draw()
end;